/*
SAVList (C) 2005 Tatsuhiko Shoji
The sources for SAVList are distributed under the MIT open source license
*/
#include	<stdio.h>
#include	<stdlib.h>
#include	"savFile.h"

/* Yۂ̃ZN^ԍAl0n܂(4+SECTORSIZE)oCgubN̔ԍ */
static unsigned long sectorTable[SECTORS];
/* őubNԍ */
static unsigned long maxBlock;

/* ZN^ԍe[uɉztbs[t@C̓eǂݍށB */
int initialize(FILE *fpi)
{
	unsigned char head[4];
	long sector,blockNo;
	size_t ioCount;
	int result = 0,i,j,seekResult;

	for (i = 0;i < SECTORS;i++){
		sectorTable[i] = 0xffffffff;
	}

	blockNo = 0;
	while(feof(fpi) == 0){
		/* ŏ4oCgZN^ԍ */
		ioCount = fread(head,1,4,fpi);
		if (ioCount < 4){
			if (ferror(fpi)){
				result = 1;
			}
			break;
		}

		/* ZN^̒g͔΂B */
		/* printf("seek\n"); */
		seekResult = fseek(fpi,SECTORSIZE,SEEK_CUR);
		if (seekResult){
			result = 1;
			break;
		}
		if (ferror(fpi)){
			result = 1;
			break;
		}

		/* ŏ4oCgZN^ԍ */
		sector = 0;
		for (j = 0;j < 4;j++){
			sector = sector << 8;
			sector = sector | head[3 - j];
		}
		/* őZN^傫ZN^ԍoĂ琳ȃt@Cł͂Ȃ̂ŔB */
		if (sector >= SECTORS){
			fprintf(stderr,"Bad virtual floppy disk file.\n");
			result = 1;
			break;
		}
		/* ZN^ԍ2xoĂ琳ȃt@Cł͂Ȃ̂ŔB */
		if (sectorTable[sector] != 0xffffffff){
			fprintf(stderr,"Bad virtual floppy disk file.\n");
			result = 1;
			break;
		}
		
		sectorTable[sector] = blockNo;
		blockNo++;
	}
	maxBlock = blockNo;

	return result;
}

/* ztbs[fBXNt@C̃ZN^ǂݍ */
int readSector(FILE *fpi,unsigned long sectorNo,void *buf)
{
	long sectorPos;
	size_t ioCount;

	/* ݂ȂZN^ԍw肵ꍇAG[ƂB */
	if (sectorNo >= SECTORS){
		return 1;
	}

	/* ztbs[ɑ݂Ȃt@CG[ɂB */
	if (sectorTable[sectorNo] == 0xffffffff){
		return 1;
	}

	/* t@C̈ʒuɒB */
	sectorPos = (long)(sectorTable[sectorNo] * (4 + SECTORSIZE));

	fseek(fpi,sectorPos + 4,SEEK_SET);
	ioCount = fread(buf,SECTORSIZE,1,fpi);
	if (ioCount < 1){
		return 1;
	}
	return 0;
}

/* ztbs[fBXNt@C̃ZN^ɏ */
int writeSector(FILE *fpo,unsigned long sectorNo,void *buf)
{
	long sectorPos;
	size_t ioCount;
	unsigned char secNoBuf[4];
	
	/* ݂ȂZN^ԍw肵ꍇAG[ƂB */
	if (sectorNo >= SECTORS){
		return 1;
	}

	/* ztbs[ɑ݂Ȃt@CԍŌɏB */
	if (sectorTable[sectorNo] == 0xffffffff){
		fseek(fpo,maxBlock * (4 + SECTORSIZE),SEEK_SET);

		sectorTable[sectorNo] = maxBlock;
		secNoBuf[0] = (unsigned char)(sectorNo & 0xff);
		secNoBuf[1] = (unsigned char)((sectorNo >> 8) & 0xff);
		secNoBuf[2] = (unsigned char)((sectorNo >> 16) & 0xff);
		secNoBuf[3] = (unsigned char)((sectorNo >> 24) & 0xff);
		
		maxBlock++;
		
		/* ZN^ԍށB */
		ioCount = fwrite(secNoBuf,4,1,fpo);
		if (ioCount < 1){
			return 1;
		}
		
	}else{
		/* t@C̈ʒuɒB */
		sectorPos = (long)(sectorTable[sectorNo] * (4 + SECTORSIZE));

		fseek(fpo,sectorPos + 4,SEEK_SET);
	}

	ioCount = fwrite(buf,SECTORSIZE,1,fpo);
	if (ioCount < 1){
		return 1;
	}
	return 0;
}
