/*
SAVList (C) 2005 Tatsuhiko Shoji
The sources for SAVList are distributed under the MIT open source license
*/
#include	<windows.h>
#include	<commctrl.h>
#include	<shlobj.h>
#include	<objbase.h>
#include	<Commdlg.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	"readSav.h"
#include	"resource.h"
#include	"verDialog.h"

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
ATOM InitApp(HINSTANCE);
BOOL InitInstance(HINSTANCE,int);
LRESULT CommandProc(HWND hWnd,UINT msg,WPARAM wp,LPARAM lp);

HWND MakeMyList(HWND);
void InsertMyColumn(HWND);

void openSavFileSelect(void);
void openSavFile(char *filename);
void transferFiles(void);
void putTransferErrorMessage(int result);
void extractFiles(void);
int dirselect(HWND hWnd,char *buf);
void queryDeleteFiles(void);
void queryLFNKill(void);
void directoryUpKey(void);
void selectSubDirectory(void);
void setStatusBarInfo(void);
void displayHelpFile(void);
void versionDialog(void);

#define EXE_NAME "savlist.exe"
#define MAN_NAME "SLhelp.html"

// EChEp`
#define	WS_EX_LAYERED 0x80000
#define LWA_ALPHA 2
typedef DWORD (WINAPI *FWINLAYER)(HWND hwnd,DWORD crKey,BYTE bAlpha,DWORD dwFlags);
int winVer,minorVer;
HINSTANCE hDLL;
FWINLAYER pfWin = NULL;

char szClassName[] = "savlist_class";
HWND hWndMain;	// CEChẼnh
HWND hList;	// Xg̃nh
HWND hStatus;	// Xe[^Xo[̃EChEnh
HINSTANCE hInst;	// CX^Xnh
bool readFlag = false;

int WINAPI WinMain(HINSTANCE hCurInst,HINSTANCE hPrevInst,LPSTR lpsCmdLine,int nCmdShow)
{
	MSG msg;
	INITCOMMONCONTROLSEX ic;
	HACCEL hAccel;

    DWORD dwver;

    dwver = GetVersion();
	winVer = LOBYTE(dwver);
	if (winVer < 4){	// Windows NT 3.xx`FbN
		MessageBox(NULL,"Windows 95/NT4ȍ~Windowsł̂\n삵܂B","l",MB_OK);
		return(0);
	}
	minorVer = HIBYTE(dwver);

	CoInitialize(NULL);

	ic.dwSize = sizeof(INITCOMMONCONTROLSEX);
	ic.dwICC = ICC_LISTVIEW_CLASSES;
	InitCommonControlsEx(&ic);

	hInst = hCurInst;
	
	if (!InitApp(hCurInst)){
		return FALSE;
	}
	
	if (!InitInstance(hCurInst,nCmdShow)){
		return FALSE;
	}

	hAccel = LoadAccelerators(hCurInst,MAKEINTRESOURCE(IDR_ACCELERATOR1));
	
	// bZ[W
	while (GetMessage(&msg,NULL,0,0)){
		if (!TranslateAccelerator(hWndMain,hAccel,&msg)){
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return (int)msg.wParam;
	
}

// CEChẼEChENXo^B
ATOM InitApp(HINSTANCE hInst)
{
	WNDCLASSEX wc;
	
	wc.cbSize = sizeof(WNDCLASSEX);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInst;
	wc.hIcon = LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON1));
	wc.hCursor = LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName = MAKEINTRESOURCE(IDR_MENU1);
	wc.lpszClassName = (LPCSTR)szClassName;
	wc.hIconSm = (HICON)LoadImage(hInst,MAKEINTRESOURCE(IDI_ICON1),IMAGE_ICON,
							16,16,LR_DEFAULTSIZE);
	
	return(RegisterClassEx(&wc));
	
}

// CEChE쐬B
BOOL InitInstance(HINSTANCE hInst,int nCmdShow)
{
	HWND hWnd;
	
	hWnd = CreateWindow(szClassName,
			"SAVList",
			WS_OVERLAPPEDWINDOW,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			475,
			400,
			HWND_DESKTOP,
			NULL,
			hInst,
			NULL);
	if (hWnd == NULL){
		return FALSE;
	}
	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);
	hWndMain = hWnd;	// CEChẼnhۑB
	
	return TRUE;
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT msg,WPARAM wp,LPARAM lp)
{
	RECT rc;
	LPNMHDR nm;
	
	switch (msg){
		case WM_CREATE:
			if (winVer > 4){
				LONG info;

				info = GetWindowLong(hWnd,GWL_EXSTYLE);	// gX^CQbg
				SetWindowLong(hWnd,GWL_EXSTYLE,info | WS_EX_LAYERED);

				hDLL = LoadLibrary("user32.dll");
				pfWin = (FWINLAYER)GetProcAddress(hDLL,"SetLayeredWindowAttributes");
				if (pfWin != NULL)
					pfWin(hWnd,0,255,LWA_ALPHA);
			}

			hList = MakeMyList(hWnd);
			InsertMyColumn(hList);
			//InsertMyItem(hList);
			if (__argc > 1){
				openSavFile(__argv[1]);
			}
		break;
		case WM_SIZE:
			RECT statusRect;
			SendMessage(hStatus,msg,wp,lp);
			GetWindowRect(hStatus,&statusRect);
			GetClientRect(hWnd,&rc);
			MoveWindow(hList,0,0,rc.right - rc.left,
				rc.bottom - rc.top - (statusRect.bottom - statusRect.top)
				,TRUE);
		break;
		case WM_NOTIFY:
			nm = (LPNMHDR)lp;
			if (nm->hwndFrom == hList){
				switch (nm->code) {
					case NM_DBLCLK:
						selectSubDirectory();
						break;
					case NM_RETURN:
						selectSubDirectory();
						break;
					default:
						return(DefWindowProc(hWnd,msg,wp,lp));
						break;
				}
			}else{
				return(DefWindowProc(hWnd,msg,wp,lp));
			}
			break;
		case WM_CLOSE:
			cleanup();
			DestroyWindow(hList);
			DestroyWindow(hWnd);
		break;
		case WM_COMMAND:
			CommandProc(hWnd,msg,wp,lp);
		break;
		case WM_DESTROY:
			PostQuitMessage(0);
		break;
		default:
			return(DefWindowProc(hWnd,msg,wp,lp));
	}
	return 0;
}

//
LRESULT CommandProc(HWND hWnd,UINT msg,WPARAM wp,LPARAM lp)
{
	switch(LOWORD(wp)){
		case IDM_OPEN:
			openSavFileSelect();
			break;
		case IDM_EXIT:
			cleanup();
			DestroyWindow(hList);
			DestroyWindow(hWndMain);
			break;
		case IDM_SELECTALL:
			if (readFlag){
				selectAllFiles(hList);
				UpdateWindow(hList);
			}
			break;
		case IDM_ADDFILE:
			transferFiles();
			break;
		case IDM_EXT:
			extractFiles();
			break;
		case IDM_DELFILES:
			queryDeleteFiles();
			break;
		case IDM_LFNKILL:
			queryLFNKill();
			break;
		case IDM_HELP:
			displayHelpFile();
			break;
		case IDM_ABOUT:
			versionDialog();
			break;
		case IDM_UPDIR:
			directoryUpKey();
			break;
		default:
			return(DefWindowProc(hWnd,msg,wp,lp));
	}

	return 0;
}

// Xgr[쐬B
HWND MakeMyList(HWND hWnd)
{
	HWND hList;
	DWORD dwStyle;
	LONG style;
	
	/* Xgr[ */
	hList = CreateWindowEx(0,WC_LISTVIEW,"",
		WS_CHILD | WS_VISIBLE | LVS_REPORT | WS_EX_CLIENTEDGE | LVS_NOSORTHEADER ,0,0,0,0,
		hWnd,(HMENU)100,hInst,NULL);
	style = GetWindowLong(hList,GWL_STYLE);
	if (style & LVS_EDITLABELS){
		style = style ^ LVS_EDITLABELS;
		SetWindowLong(hList, GWL_STYLE, style);
	}
	dwStyle = ListView_GetExtendedListViewStyle(hList);
	dwStyle |= LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES | LVS_EX_HEADERDRAGDROP;	// | LVS_EX_CHECKBOXES;
	ListView_SetExtendedListViewStyle(hList,dwStyle);
	
	/* łɃXe[^Xo[B */
	hStatus = CreateWindowEx(0,STATUSCLASSNAME,NULL,WS_CHILD | WS_VISIBLE | CCS_BOTTOM,
		0,0,0,0,hWnd,(HMENU)39999,hInst,NULL);

	return hList;
}

// J}B
void InsertMyColumn(HWND hList)
{
	LV_COLUMN lvcol;
	
	lvcol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	lvcol.fmt = LVCFMT_LEFT;
	lvcol.cx = 80;
	lvcol.pszText = "Gg";
	lvcol.iSubItem = 0;
	ListView_InsertColumn(hList,0,&lvcol);

	lvcol.cx = 130;
	lvcol.pszText = "t@C";
	lvcol.iSubItem = 1;
	ListView_InsertColumn(hList,1,&lvcol);
	
	lvcol.cx = 90;
	lvcol.pszText = "TCY";
	lvcol.iSubItem = 2;
	ListView_InsertColumn(hList,2,&lvcol);

	lvcol.cx = 130;
	lvcol.pszText = "XV";
	lvcol.iSubItem = 3;
	ListView_InsertColumn(hList,3,&lvcol);
	
	return;
}

/*
	ztbs[fBXNt@CI_CAOoB
	
		Ȃ
	߂l
		Ȃ
*/
void openSavFileSelect(void)
{
	OPENFILENAME ofn;
	char GotFileName[256];

	memset(GotFileName,0x00,sizeof(GotFileName));
	memset(&ofn,0x00,sizeof(OPENFILENAME));
//	if ((winVer > 4) || ((winVer == 4) && (minorVer > 89))){
		ofn.lStructSize = sizeof(OPENFILENAME);
//	}else{
//		ofn.lStructSize = OPENFILENAME_SIZE_VERSION_400;
//	}
	ofn.hwndOwner = hWndMain;
	ofn.lpstrFilter = "ztbs[fBXNt@C(*.SAV)\0*.SAV\0fBXNC[Wt@C(*.DSK)\0*.DSK\0SẴt@C (*.*)\0*.*\0";
	ofn.Flags = OFN_FILEMUSTEXIST;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = GotFileName;
	ofn.nMaxFile = 256;
	ofn.lpstrTitle = "ztbs[fBXNt@CJ";

	if (GetOpenFileName(&ofn)){
		openSavFile(GotFileName);
	}
}

/* ztbs[fBXNt@CJ */
void openSavFile(char *filename)
{
	char title[_MAX_PATH + 32];
	int result;

	cleanup();

	// fBXNC[WǂݍށB
	result = readSavFile(filename);
	if (result){
		return;
	}
	/* ^CgƃXe[^Xo[̏ԂXVB */
	sprintf(title,"%s - SAVList",filename);
	SetWindowText(hWndMain,title);
	setStatusBarInfo();
	// Xgr[ɔfB
	refreshDir(hList);
	readFlag = true;
	ListView_SetItemState(hList,0,1,LVIS_FOCUSED);
	SetFocus(hList);
	// fBNgĕ\B
	UpdateWindow(hList);
	UpdateWindow(hStatus);
}


/* t@Cztbs[fBXNɓ] */
void transferFiles(void)
{
	OPENFILENAME ofn;
	char *gotFileName;
	char path[260];
	char *p;
	int result;

	if (!readFlag){
		MessageBox(hWndMain,"ztbs[fBXNt@CǂݍłB","G[",MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	gotFileName = (char *)malloc(10240);
	if (gotFileName == NULL){
		return;
	}

	memset(gotFileName,0x00,10240);
	memset(&ofn,0x00,sizeof(OPENFILENAME));
//	if ((winVer > 4) || ((winVer == 4) && (minorVer > 89))){
		ofn.lStructSize = sizeof(OPENFILENAME);
//	}else{
//		ofn.lStructSize = OPENFILENAME_SIZE_VERSION_400;
//	}
	ofn.hwndOwner = hWndMain;
	ofn.lpstrFilter = "SẴt@C (*.*)\0*.*\0";
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_ALLOWMULTISELECT | OFN_EXPLORER;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = gotFileName;
	ofn.nMaxFile = 10240;
	ofn.lpstrTitle = "]t@CI";

	if (GetOpenFileName(&ofn)){
		p = gotFileName + ofn.nFileOffset;

		if (ofn.nFileOffset > 0){
			if (*(p - 1) != '\0'){
				// t@C1̂Ƃ̓tpXB
				strcpy(path,gotFileName);

				result = writeFile(path);
				if (result){
					putTransferErrorMessage(result);
				}
			}else{
				// t@C2ȏ̂Ƃ
				// fBNg\0t@C1\0()\0\0
				do{
					strcpy(path,gotFileName);
					strcat(path,"\\");
					strcat(path,p);

					result = writeFile(path);
					if (result){
						putTransferErrorMessage(result);
						break;
					}

					while(*p){
						p++;
					}
					p++;

				}while(*p);
			}
		}
		// Xe[^Xo[XVB
		setStatusBarInfo();
		// fBNgĕ\B
		refreshDir(hList);
		UpdateWindow(hList);
		UpdateWindow(hStatus);
	}
	free(gotFileName);
}

/* t@C]̃G[bZ[W\ */
void putTransferErrorMessage(int result)
{
	if (result == NO_DISKSPACE){
		MessageBox(hWndMain,"ztbs[fBXNɋ󂫂܂B","G["
					,MB_OK | MB_ICONEXCLAMATION);
	}else if (result == NO_ENTRY){
		MessageBox(hWndMain,"fBNgGg̋󂫂܂B","G["
					,MB_OK | MB_ICONEXCLAMATION);
	}else{
		MessageBox(hWndMain,"t@C]Ɏs܂B","G[",MB_OK | MB_ICONEXCLAMATION);
	}
}

/* Iꂽt@CWJB */
void extractFiles(void)
{
	int count,i;
	UINT state;
	char buf[_MAX_PATH];

	if (!readFlag){
		MessageBox(hWndMain,"ztbs[fBXNt@CǂݍłB","G["
					,MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	count = ListView_GetSelectedCount(hList);
	if (!count){
		MessageBox(hWndMain,"WJt@Cw肵ĂB","G["
					,MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	// WJpX擾B
	if (dirselect(hWndMain,buf)){
		return;
	}

	// Iꂽt@CāAt@CWJĂB
	count = ListView_GetItemCount(hList);
	for (i = 0;i < count;i++){
		// Xgr[̑IԂ擾B
		state = ListView_GetItemState(hList,i,LVIS_SELECTED);
		if (state){
			extractFile(buf,i);
		}
		ListView_SetItemState(hList,i,0,LVIS_SELECTED);
	}
	UpdateWindow(hList);
	UpdateWindow(hStatus);
}

/* WJfBNgIB */
int dirselect(HWND hWnd,char *buf)
{
	BROWSEINFO info;
	ITEMIDLIST *lpid;
	char dir[MAX_PATH];

    HRESULT hr;
    LPMALLOC pMalloc = NULL;//IMallocւ̃|C^

	memset(&info, 0, sizeof(BROWSEINFO));
	info.hwndOwner = hWnd;	//eEChEnh
	info.pszDisplayName = dir;	// ʂobt@
	info.lpszTitle = "^[QbgfBNg̑I";
	info.ulFlags = BIF_RETURNONLYFSDIRS ;
	info.pidlRoot = NULL;	// fBNg
	info.lpfn = NULL;	// CxgN̊֐
	info.lParam = (LPARAM)0;

	lpid = SHBrowseForFolder(&info);
	if (lpid == NULL) {
		return 1;
	} else {
        hr = SHGetMalloc(&pMalloc);
        if (hr == E_FAIL) {
            MessageBox(hWnd, "SHGetMalloc Error", "Error", MB_OK);
            return 1;
        }
        SHGetPathFromIDList(lpid, buf);
		//_SHFree(lpid);
		//SendMessage(control[EDIT_DIR],WM_SETTEXT,(WPARAM)0,(LPARAM)buf);
		//MessageBox(hWnd,buf,"Selected",MB_OK);

		pMalloc->Free(lpid);
		pMalloc->Release();

		// bufɑ΂ēWJsB
	}
	return 0;
}

/* t@C폜邩ǂ₢킹Ă폜B */
void queryDeleteFiles(void)
{
	int result;

	if (!readFlag){
		MessageBox(hWndMain,"ztbs[fBXNt@CǂݍłB","G["
					,MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	if (ListView_GetSelectedCount(hList) < 1){
		MessageBox(hWndMain,"t@CIĂsĂB","G["
					,MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	result = MessageBox(hWndMain,"It@C폜܂H","mF"
		,MB_YESNO | MB_ICONQUESTION | MB_DEFBUTTON2);

	if (result == IDYES){
		deleteSelectedFiles(hList);

		// Xe[^Xo[XVB
		setStatusBarInfo();
		// Xgr[ɔfB
		// fBNgĕ\B
		refreshDir(hList);
		UpdateWindow(hList);
		UpdateWindow(hStatus);
	}
	ListView_SetItemState(hList,0,1,LVIS_FOCUSED);
	SetFocus(hList);
}

/* t@C폜邩ǂ₢킹Ă폜B */
void queryLFNKill(void)
{
	int result;

	if (!readFlag){
		MessageBox(hWndMain,"ztbs[fBXNt@CǂݍłB","G["
					,MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	result = MessageBox(hWndMain,"Ot@C폜܂H","mF"
		,MB_YESNO | MB_ICONQUESTION | MB_DEFBUTTON2);

	if (result == IDYES){
		deleteLongFilename(hList);

		// Xe[^Xo[XVB
		setStatusBarInfo();
		// Xgr[ɔfB
		// fBNgĕ\B
		refreshDir(hList);
		UpdateWindow(hList);
		UpdateWindow(hStatus);
	}
	ListView_SetItemState(hList,0,1,LVIS_FOCUSED);
	SetFocus(hList);
}

/* TufBNg_uNbNƂ̓ */
void selectSubDirectory(void)
{
	int count,i;
	UINT state;

	if (!readFlag){
		return;
	}

	count = ListView_GetSelectedCount(hList);
	if (!count){
		return;
	}

	// Iꂽt@CāAt@CWJĂB
	count = ListView_GetItemCount(hList);
	for (i = 0;i < count;i++){
		// Xgr[̑IԂ擾B
		state = ListView_GetItemState(hList,i,LVIS_SELECTED);
		if (state){
			ListView_SetItemState(hList,i,0,LVIS_SELECTED);
			enterDirectory(hList,i);
			break;
		}
	}
	// Xe[^Xo[XVB
	setStatusBarInfo();
	// fBNgXgXVB
	UpdateWindow(hList);
	UpdateWindow(hStatus);
	ListView_SetItemState(hList,0,1,LVIS_FOCUSED);
	SetFocus(hList);
	
}

/* TufBNg_uNbNƂ̓ */
void directoryUpKey(void)
{
	if (!readFlag){
		return;
	}

	if (upDirectory(hList)){
		// Xe[^Xo[XVB
		setStatusBarInfo();
		// fBNgXgXVB
		UpdateWindow(hList);
		UpdateWindow(hStatus);
		ListView_SetItemState(hList,0,1,LVIS_FOCUSED);
		SetFocus(hList);
	}
	
}

/* Xe[^Xo[ɏݒ肷B */
void setStatusBarInfo(void)
{
	struct SavStatus status;
	char buf[256];

	getSavStatus(&status);
	sprintf(buf,"%ld Files %ld Directorys Free:%ld Total:%ld",
		status.files,status.directorys,status.freeSize,status.maxSize);
	SetWindowText(hStatus,buf);
}

void displayHelpFile(void)
{
	DWORD result;
	char pathname[MAX_PATH],curDir[_MAX_DIR+_MAX_DRIVE+1],drive[_MAX_DRIVE+1],dir[_MAX_DIR+1];
	HMODULE ModHdl;
	char helpFile[MAX_PATH];
	HINSTANCE inst;

	// st@C̃fBNg𓾂B
	ModHdl = GetModuleHandle(NULL);
	if (ModHdl == NULL)
		return;
	result = GetModuleFileName(ModHdl,pathname,MAX_PATH);

	_splitpath(pathname,drive,dir,NULL,NULL);

	curDir[0] = '\0';
	strcpy(curDir,drive);
	strcat(curDir,dir);

	strcpy(helpFile,curDir);
	strcat(helpFile,MAN_NAME);

	//inst = ShellExecute(hWnd,"open",MAN_NAME,NULL,curDir,SW_SHOWNORMAL);
	inst = ShellExecute(NULL,"open",helpFile,NULL,NULL,SW_SHOWNORMAL);
}

void versionDialog(void)
{
	// Windows 2000/XPŃEChE𓧖B
	if ((winVer > 4) && (pfWin != NULL))
		pfWin(hWndMain,0,192,LWA_ALPHA);

	// o[W_CAO\B
	DialogBox(hInst,MAKEINTRESOURCE(IDD_VERSIONDIALOG),hWndMain,VerDialogProc);

	// Windows 2000/XPŃEChEɖ߂B
	if ((winVer > 4) && (pfWin != NULL))
		pfWin(hWndMain,0,255,LWA_ALPHA);
}
